  
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     The ODE Function of Chemical Model File
C     
C     Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
C     (http://www.cs.vt.edu/~asandu/Software/KPP)
C     KPP is distributed under GPL, the general public licence
C     (http://www.gnu.org/copyleft/gpl.html)
C     (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
C     (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
C     With important contributions from:
C     M. Damian, Villanova University, USA
C     R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
C     
C     File                 : CMAQ_CB4_Function.f90
C     Time                 : Tue Apr 18 11:38:47 2006
C     Working directory    : /home/amir/Desktop/KPP/kpp-2.1
C     Equation file        : CMAQ_CB4.kpp
C     Output root filename : CMAQ_CB4
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      
      
      
      MODULE KPP_FUNCTION
      
      USE KPP_PARS
      
      IMPLICIT NONE
      
C     A - Rate for each equation
      REAL(kind=dp) :: A(KPPNRCT)
      
      CONTAINS
      
      
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     Fun - time derivatives of variables - Agregate form
C     Arguments :
C     V         - Concentrations of variable species (local)
C     F         - Concentrations of fixed species (local)
C     RCT       - Rate constants (local)
C     Vdot      - Time derivative of variable species concentrations
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      
      SUBROUTINE Fun ( V, RCT, Vdot )
      
C     V - Concentrations of variable species (local)
      REAL(kind=dp) :: V(KPPNSP)
C     RCT - Rate constants (local)
      REAL(kind=dp) :: RCT(KPPNRCT)
C     Vdot - Time derivative of variable species concentrations
      REAL(kind=dp) :: Vdot(KPPNSP)
      
      
C     Computation of equation rates
      A(1) = RCT(1)*V(35)
      A(2) = RCT(2)*V(32)
      A(3) = RCT(3)*V(34)*V(36)
      A(4) = RCT(4)*V(32)*V(35)
      A(5) = RCT(5)*V(32)*V(35)
      A(6) = RCT(6)*V(32)*V(36)
      A(7) = RCT(7)*V(34)*V(35)
      A(8) = RCT(8)*V(34)
      A(9) = RCT(9)*V(34)
      A(10) = RCT(10)*V(3)
      A(11) = RCT(11)*V(3)
      A(12) = RCT(12)*V(3)
      A(13) = RCT(13)*V(31)*V(34)
      A(14) = RCT(14)*V(30)*V(34)
      A(15) = RCT(15)*V(33)
      A(16) = RCT(16)*V(33)*V(36)
      A(17) = RCT(17)*V(33)*V(35)
      A(18) = RCT(18)*V(33)*V(35)
      A(19) = RCT(19)*V(9)
      A(20) = RCT(20)*V(9)
      A(21) = RCT(21)*V(36)*V(36)
      A(22) = RCT(22)*V(35)*V(36)
      A(23) = RCT(23)*V(31)*V(36)
      A(24) = RCT(24)*V(11)
      A(25) = RCT(25)*V(11)*V(31)
      A(26) = RCT(26)*V(11)*V(11)
      A(27) = RCT(27)*V(31)*V(35)
      A(28) = RCT(28)*V(14)*V(31)
      A(29) = RCT(29)*V(30)*V(36)
      A(30) = RCT(30)*V(30)*V(35)
      A(31) = RCT(31)*V(12)
      A(32) = RCT(32)*V(12)*V(31)
      A(33) = RCT(33)*V(30)*V(30)
      A(34) = RCT(34)*V(30)*V(30)
      A(35) = RCT(35)*V(5)
      A(36) = RCT(36)*V(5)*V(31)
      A(37) = RCT(37)*V(18)*V(31)
      A(38) = RCT(38)*V(25)*V(31)
      A(39) = RCT(39)*V(25)
      A(40) = RCT(40)*V(25)
      A(41) = RCT(41)*V(25)*V(32)
      A(42) = RCT(42)*V(25)*V(33)
      A(43) = RCT(43)*V(28)*V(32)
      A(44) = RCT(44)*V(28)*V(31)
      A(45) = RCT(45)*V(28)*V(33)
      A(46) = RCT(46)*V(28)
      A(47) = RCT(47)*V(29)*V(36)
      A(48) = RCT(48)*V(29)*V(35)
      A(49) = RCT(49)*V(6)
      A(50) = RCT(50)*V(29)*V(29)
      A(51) = RCT(51)*V(29)*V(30)
      A(52) = RCT(52)*V(31)
      A(53) = RCT(53)*V(24)*V(31)
      A(54) = RCT(54)*V(15)
      A(55) = RCT(55)*V(15)
      A(56) = RCT(56)*V(15)*V(35)
      A(57) = RCT(57)*V(23)*V(32)
      A(58) = RCT(58)*V(23)*V(31)
      A(59) = RCT(59)*V(23)*V(34)
      A(60) = RCT(60)*V(23)*V(33)
      A(61) = RCT(61)*V(19)*V(32)
      A(62) = RCT(62)*V(19)*V(31)
      A(63) = RCT(63)*V(19)*V(34)
      A(64) = RCT(64)*V(8)*V(31)
      A(65) = RCT(65)*V(13)*V(36)
      A(66) = RCT(66)*V(13)
      A(67) = RCT(67)*V(16)*V(31)
      A(68) = RCT(68)*V(16)*V(33)
      A(69) = RCT(69)*V(7)*V(35)
      A(70) = RCT(70)*V(10)*V(31)
      A(71) = RCT(71)*V(20)*V(31)
      A(72) = RCT(72)*V(20)
      A(73) = RCT(73)*V(20)*V(34)
      A(74) = RCT(74)*V(17)*V(31)
      A(75) = RCT(75)*V(17)
      A(76) = RCT(76)*V(26)*V(32)
      A(77) = RCT(77)*V(26)*V(31)
      A(78) = RCT(78)*V(26)*V(34)
      A(79) = RCT(79)*V(26)*V(33)
      A(80) = RCT(80)*V(22)*V(36)
      A(81) = RCT(81)*V(22)*V(22)
      A(82) = RCT(82)*V(21)*V(36)
      A(83) = RCT(83)*V(4)*V(31)
      A(84) = RCT(84)*V(4)
      A(85) = RCT(85)*V(22)*V(30)
      A(86) = RCT(86)*V(21)*V(30)
      A(87) = RCT(87)*V(21)*V(21)
      A(88) = RCT(88)*V(21)*V(22)
      A(89) = RCT(89)*V(27)*V(31)
      A(90) = RCT(90)*V(27)*V(34)
      A(91) = RCT(91)*V(27)*V(33)
      A(92) = RCT(92)*V(27)
      A(93) = RCT(93)*V(26)*V(35)

C     Aggregate function
      Vdot(1) = A(56)+0.1*A(65)+A(69)+0.8*A(79)+A(82)+0.85*A(91)+0.8*A(93)
      Vdot(2) = A(83)+A(84)
      Vdot(3) = A(9)-A(10)-A(11)-A(12)
      Vdot(4) = -A(83)-A(84)
      Vdot(5) = A(33)+A(34)-A(35)-A(36)
      Vdot(6) = A(48)-A(49)
      Vdot(7) = 0.4*A(67)+A(68)-A(69)
      Vdot(8) = -A(64)
      Vdot(9) = A(18)-A(19)-A(20)
      Vdot(10) = -A(70)
      Vdot(11) = 2*A(22)+A(23)-A(24)-A(25)-2*A(26)
      Vdot(12) = A(30)-A(31)-A(32)
      Vdot(13) = 0.56*A(64)-A(65)-A(66)+0.3*A(70)
      Vdot(14) = 2*A(19)+A(27)-A(28)+A(42)+A(45)+A(68)+0.15*A(91)
      Vdot(15) = 0.76*A(53)-0.98*A(54)-A(55)-A(56)
      Vdot(16) = 0.36*A(64)+A(66)-A(67)-A(68)+0.2*A(70)
      Vdot(17) = 0.8*A(70)+0.2*A(73)-A(74)-A(75)+0.17*A(89)+0.85*A(90)
      Vdot(18) = -A(37)+A(38)+A(39)+A(40)+A(41)+A(42)+A(46)+0.3*A(57)+0.33*A(59)+A(61)+0.42*A(63)+2*A(71)+A(72)+0.69*A(73)
     &     +A(75)+0.07*A(78)+0.33*A(89)+0.23*A(90)+0.64*A(91)+0.33*A(92)
      Vdot(19) = -A(61)-A(62)-A(63)
      Vdot(20) = 0.9*A(65)+0.3*A(67)-A(71)-A(72)-A(73)
      Vdot(21) = 0.13*A(53)+0.04*A(54)+0.02*A(57)+0.09*A(60)+0.09*A(77)-A(82)-A(86)-2*A(87)-A(88)
      Vdot(22) = A(46)+A(47)+2*A(50)+0.79*A(51)+A(52)+0.87*A(53)+0.96*A(54)+0.28*A(57)+A(58)+0.22*A(59)+0.91*A(60)+0.7*A(61)
     &     +A(62)+0.08*A(64)+0.6*A(67)+0.5*A(70)+A(71)+0.03*A(73)+A(74)+0.25*A(76)+0.99*A(77)+0.2*A(78)+A(79)-A(80)-2
     &     *A(81)-A(85)-A(88)+0.71*A(89)+0.06*A(90)+0.08*A(91)+0.7*A(92)+A(93)
      Vdot(23) = -A(57)-A(58)-A(59)-A(60)
      Vdot(24) = -1.11*A(53)-2.1*A(54)+0.22*A(57)-A(58)-A(59)-A(60)+1.1*A(70)+0.25*A(76)+0.35*A(78)+2.4*A(79)+1.57*A(89)
     &     +0.36*A(90)+1.28*A(91)+0.83*A(92)+2.4*A(93)
      Vdot(25) = -A(38)-A(39)-A(40)-A(41)-A(42)+A(46)+A(47)+2*A(50)+0.79*A(51)+A(52)+0.2*A(57)+A(58)+0.74*A(59)+A(60)+A(61)
     &     +1.56*A(62)+A(63)+A(71)+0.7*A(73)+0.5*A(76)+0.63*A(77)+0.6*A(78)+0.17*A(89)+0.15*A(90)+0.28*A(91)+0.9*A(92)
      Vdot(26) = -A(76)-A(77)-A(78)-A(79)-A(93)
      Vdot(27) = 0.75*A(76)+0.91*A(77)+0.65*A(78)+0.2*A(79)-A(89)-A(90)-A(91)-A(92)+0.2*A(93)
      Vdot(28) = -A(43)-A(44)-A(45)-A(46)+0.11*A(53)+1.1*A(54)+0.63*A(57)+A(58)+0.5*A(59)+A(60)+0.22*A(62)+0.03*A(73)+0.15
     &     *A(78)+0.8*A(79)+0.27*A(89)+0.02*A(90)+0.36*A(91)+0.07*A(92)+0.8*A(93)
      Vdot(29) = A(43)+A(44)+A(45)-A(47)-A(48)+A(49)-2*A(50)-A(51)+A(71)+A(72)+0.62*A(73)+A(74)+A(75)+0.25*A(76)+0.2*A(78)
     &     +0.5*A(89)+0.11*A(90)+0.08*A(91)+0.97*A(92)
      Vdot(30) = A(13)-A(14)-A(29)-A(30)+A(31)-2*A(33)-2*A(34)+A(36)+A(37)+A(38)+2*A(39)+A(41)+A(42)+2*A(46)+A(47)+2*A(50)
     &     -0.21*A(51)+A(52)+0.11*A(53)+0.94*A(54)+A(55)+0.38*A(57)+A(58)+0.44*A(59)+1.7*A(61)+A(62)+0.12*A(63)+0.44
     &     *A(64)+0.9*A(65)+A(66)+0.6*A(67)+0.7*A(70)+2*A(71)+A(72)+0.76*A(73)+A(75)+0.25*A(76)+0.91*A(77)+0.07*A(78)
     &     +0.8*A(79)+A(83)-A(85)-A(86)+0.5*A(89)+0.15*A(90)+0.93*A(91)+1.03*A(92)+0.8*A(93)
      Vdot(31) = 2*A(12)-A(13)+A(14)-A(23)+A(24)-A(25)-A(27)-A(28)+A(29)-A(32)+2*A(35)-A(36)-A(37)-A(38)+A(41)+A(43)-A(44)
     &     +0.79*A(51)-A(52)-A(53)+0.2*A(57)-A(58)+0.1*A(59)+0.3*A(61)-A(62)-A(64)-A(67)-A(70)-A(71)+0.08*A(73)-A(74)
     &     -A(77)+0.27*A(78)-A(83)-A(89)+0.27*A(90)
      Vdot(32) = A(1)-A(2)-A(4)-A(5)-A(6)+A(8)+A(10)+A(11)+0.89*A(15)-A(41)-A(43)-A(57)-A(61)-A(76)
      Vdot(33) = A(5)+A(7)-A(15)-A(16)-A(17)-A(18)+A(20)+A(28)-A(42)-A(45)-A(60)-A(68)-A(79)-A(91)
      Vdot(34) = A(2)-A(3)-A(7)-A(8)-A(9)-A(13)-A(14)-A(59)-A(63)-A(73)-A(78)-A(90)
      Vdot(35) = -A(1)+A(3)-A(4)-A(5)+A(6)-A(7)+0.89*A(15)+2*A(16)-A(18)+A(20)+2*A(21)-A(22)+A(25)+A(26)-A(27)+A(29)-A(30)
     &     +A(31)+A(32)+A(47)-A(48)+A(49)-A(56)+A(60)+0.9*A(65)-A(69)+0.2*A(79)+A(80)-A(93)
      Vdot(36) = A(1)-A(3)+A(4)-A(6)+0.11*A(15)-A(16)+A(17)-2*A(21)-A(22)-A(23)+A(24)+A(26)-A(29)-A(47)-A(65)-A(80)-A(82)
     &     +0.2*A(93)
      
      END SUBROUTINE Fun

C     End of Fun function
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



      END MODULE KPP_Function
