  
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     Parameter Module File
C     
C     Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
C     (http://www.cs.vt.edu/~asandu/Software/KPP)
C     KPP is distributed under GPL, the general public licence
C     (http://www.gnu.org/copyleft/gpl.html)
C     (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
C     (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
C     With important contributions from:
C     M. Damian, Villanova University, USA
C     R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
C     
C     File                 : CMAQ_CB4_Parameters.f90
C     Time                 : Tue Apr 18 15:57:11 2006
C     Working directory    : /home/amir/Desktop/KPP/kpp-2.1
C     Equation file        : CMAQ_CB4.kpp
C     Output root filename : CMAQ_CB4
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



      MODULE KPP_PARS

      USE KPP_PRECISION
      PUBLIC
      SAVE


C     NSPEC - Number of chemical species
      INTEGER, PARAMETER :: KPPNSP = 36 
C     NVAR - Number of Variable species
C     INTEGER, PARAMETER :: NVAR = 36 
C     NVARACT - Number of Active species
C     INTEGER, PARAMETER :: NVARACT = 34 
C     NFIX - Number of Fixed species
C     INTEGER, PARAMETER :: NFIX = 3 
C     NREACT - Number of reactions
      INTEGER, PARAMETER :: KPPNRCT = 93 
C     NVARST - Starting of variables in conc. vect.
C     INTEGER, PARAMETER :: NVARST = 1 
C     NFIXST - Starting of fixed in conc. vect.
C     INTEGER, PARAMETER :: NFIXST = 37 
C     NONZERO - Number of nonzero entries in Jacobian
      INTEGER, PARAMETER :: NONZERO = 320 
C     LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
      INTEGER, PARAMETER :: LU_NONZERO = 340 
C     CNVAR - (NVAR+1) Number of elements in compressed row format
C     INTEGER, PARAMETER :: CNVAR = 37 
C     NHESS - Length of Sparse Hessian
      INTEGER, PARAMETER :: NHESS = 317 
C     NLOOKAT - Number of species to look at
C     INTEGER, PARAMETER :: NLOOKAT = 39 
C     NMONITOR - Number of species to monitor
C     INTEGER, PARAMETER :: NMONITOR = 1 
C     NMASS - Number of atoms to check mass balance
C     INTEGER, PARAMETER :: NMASS = 1 
C     PI - Value of pi
C     REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 

C     Index declaration for variable species in C and VAR
C     VAR(ind_spc) = C(ind_spc)

      INTEGER, PARAMETER :: ind_NTR = 1 
      INTEGER, PARAMETER :: ind_SULF = 2 
      INTEGER, PARAMETER :: ind_O1D = 3 
      INTEGER, PARAMETER :: ind_SO2 = 4 
      INTEGER, PARAMETER :: ind_H2O2 = 5 
      INTEGER, PARAMETER :: ind_PAN = 6 
      INTEGER, PARAMETER :: ind_CRO = 7 
      INTEGER, PARAMETER :: ind_TOL = 8 
      INTEGER, PARAMETER :: ind_N2O5 = 9 
      INTEGER, PARAMETER :: ind_XYL = 10 
      INTEGER, PARAMETER :: ind_HONO = 11 
      INTEGER, PARAMETER :: ind_PNA = 12 
      INTEGER, PARAMETER :: ind_TO2 = 13 
      INTEGER, PARAMETER :: ind_HNO3 = 14 
      INTEGER, PARAMETER :: ind_ROR = 15 
      INTEGER, PARAMETER :: ind_CRES = 16 
      INTEGER, PARAMETER :: ind_MGLY = 17 
      INTEGER, PARAMETER :: ind_CO = 18 
      INTEGER, PARAMETER :: ind_ETH = 19 
      INTEGER, PARAMETER :: ind_OPEN = 20 
      INTEGER, PARAMETER :: ind_XO2N = 21 
      INTEGER, PARAMETER :: ind_XO2 = 22 
      INTEGER, PARAMETER :: ind_OLE = 23 
      INTEGER, PARAMETER :: ind_PAR = 24 
      INTEGER, PARAMETER :: ind_FORM = 25 
      INTEGER, PARAMETER :: ind_ISOP = 26 
      INTEGER, PARAMETER :: ind_ISPD = 27 
      INTEGER, PARAMETER :: ind_ALD2 = 28 
      INTEGER, PARAMETER :: ind_C2O3 = 29 
      INTEGER, PARAMETER :: ind_HO2 = 30 
      INTEGER, PARAMETER :: ind_OH = 31 
      INTEGER, PARAMETER :: ind_O = 32 
      INTEGER, PARAMETER :: ind_NO3 = 33 
      INTEGER, PARAMETER :: ind_O3 = 34 
      INTEGER, PARAMETER :: ind_NO2 = 35 
      INTEGER, PARAMETER :: ind_NO = 36 

C     Index declaration for fixed species in C
C     C(ind_spc)

      INTEGER, PARAMETER :: ind_H2O = 37 
      INTEGER, PARAMETER :: ind_O2 = 38 
      INTEGER, PARAMETER :: ind_N2 = 39 

C     Index declaration for fixed species in FIX
C     FIX(indf_spc) = C(ind_spc) = C(KPPNSP+indf_spc)

      INTEGER, PARAMETER :: indf_H2O = 1 
      INTEGER, PARAMETER :: indf_O2 = 2 
      INTEGER, PARAMETER :: indf_N2 = 3 

      END MODULE KPP_Pars

