  
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     Auxiliary Routines File
C     
C     Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
C     (http://www.cs.vt.edu/~asandu/Software/KPP)
C     KPP is distributed under GPL, the general public licence
C     (http://www.gnu.org/copyleft/gpl.html)
C     (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
C     (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
C     With important contributions from:
C     M. Damian, Villanova University, USA
C     R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
C     
C     File                 : KPP_Util.f90
C     Time                 : Tue Apr 18 15:57:11 2006
C     Working directory    : /home/amir/Desktop/KPP/kpp-2.1
C     Equation file        : CMAQ_CB4.kpp
C     Output root filename : CMAQ_CB4
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



      MODULE KPP_UTIL

      USE KPP_PARS
      IMPLICIT NONE

      CONTAINS

C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     Shuffle_user2kpp - function to copy concentrations from USER to KPP
C     Arguments :
C     V_USER    - Concentration of variable species in USER's order
C     V         - Concentrations of variable species (local)
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      SUBROUTINE Shuffle_user2kpp ( V_USER, V )

C     V_USER - Concentration of variable species in USER's order
      REAL(kind=dp) :: V_USER(KPPNSP)
C     V - Concentrations of variable species (local)
      REAL(kind=dp) :: V(KPPNSP)

      V(35) = V_USER(1)
      V(36) = V_USER(2)
      V(32) = V_USER(3)
      V(34) = V_USER(4)
      V(33) = V_USER(5)
      V(3) = V_USER(6)
      V(31) = V_USER(7)
      V(30) = V_USER(8)
      V(9) = V_USER(9)
      V(14) = V_USER(10)
      V(11) = V_USER(11)
      V(12) = V_USER(12)
      V(5) = V_USER(13)
      V(18) = V_USER(14)
      V(25) = V_USER(15)
      V(28) = V_USER(16)
      V(29) = V_USER(17)
      V(22) = V_USER(18)
      V(6) = V_USER(19)
      V(24) = V_USER(20)
      V(21) = V_USER(21)
      V(15) = V_USER(22)
      V(1) = V_USER(23)
      V(23) = V_USER(24)
      V(19) = V_USER(25)
      V(8) = V_USER(26)
      V(16) = V_USER(27)
      V(13) = V_USER(28)
      V(20) = V_USER(29)
      V(7) = V_USER(30)
      V(10) = V_USER(31)
      V(17) = V_USER(32)
      V(26) = V_USER(33)
      V(27) = V_USER(34)
      V(4) = V_USER(35)
      V(2) = V_USER(36)
      
      END SUBROUTINE Shuffle_user2kpp

C     End of Shuffle_user2kpp function
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
C     
C     Shuffle_kpp2user - function to restore concentrations from KPP to USER
C     Arguments :
C     V         - Concentrations of variable species (local)
C     V_USER    - Concentration of variable species in USER's order
C     
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      SUBROUTINE Shuffle_kpp2user ( V, V_USER )

C     V - Concentrations of variable species (local)
      REAL(kind=dp) :: V(KPPNSP)
C     V_USER - Concentration of variable species in USER's order
      REAL(kind=dp) :: V_USER(KPPNSP)

      V_USER(1) = V(35)
      V_USER(2) = V(36)
      V_USER(3) = V(32)
      V_USER(4) = V(34)
      V_USER(5) = V(33)
      V_USER(6) = V(3)
      V_USER(7) = V(31)
      V_USER(8) = V(30)
      V_USER(9) = V(9)
      V_USER(10) = V(14)
      V_USER(11) = V(11)
      V_USER(12) = V(12)
      V_USER(13) = V(5)
      V_USER(14) = V(18)
      V_USER(15) = V(25)
      V_USER(16) = V(28)
      V_USER(17) = V(29)
      V_USER(18) = V(22)
      V_USER(19) = V(6)
      V_USER(20) = V(24)
      V_USER(21) = V(21)
      V_USER(22) = V(15)
      V_USER(23) = V(1)
      V_USER(24) = V(23)
      V_USER(25) = V(19)
      V_USER(26) = V(8)
      V_USER(27) = V(16)
      V_USER(28) = V(13)
      V_USER(29) = V(20)
      V_USER(30) = V(7)
      V_USER(31) = V(10)
      V_USER(32) = V(17)
      V_USER(33) = V(26)
      V_USER(34) = V(27)
      V_USER(35) = V(4)
      V_USER(36) = V(2)
      
      END SUBROUTINE Shuffle_kpp2user

C     End of Shuffle_kpp2user function
C     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


      END MODULE KPP_UTIL

