C                           DISCLAIMER
C
C   THIS FILE WAS GENERATED BY TAMC VERSION 5.3.2
C
C   THE AUTHOR DOES NOT MAKE  ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR  RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS,
C   OR USEFULNESS  OF ANY INFORMATION OR PROCESS  DISCLOSED, OR REPRESENTS
C   THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
C   THIS CODE IS FOR NON-PROFIT-ORIENTED ACADEMIC RESEARCH AND EDUCATION
C   ONLY.  ANY COMMERCIAL OR OTHER PROFIT-ORIENTED USE OR  EVALUATION IS
C   STRICTLY  FORBIDDEN.  PASSING  THIS CODE  TO  ANY THIRD  PARTY IS  NOT
C   ALLOWED.
C
C   FOR COMMERCIAL OR  OTHER PROFIT-ORIENTED APPLICATIONS PLEASE CONTACT
C   INFO@FASTOPT.COM
C
      SUBROUTINE ADHPPM( NI, CONI, VEL, DT, DSI, ORI, ADCONI )
C***************************************************************
C***************************************************************
C** THIS ROUTINE WAS GENERATED BY THE                         **
C** TANGENT LINEAR AND ADJOINT MODEL COMPILER,  TAMC 5.3.2    **
C***************************************************************
C***************************************************************
C==============================================
C ALL ENTRIES ARE DEFINED EXPLICITLY
C==============================================
      USE HGRD_DEFN

      USE SUBST_MODULES              ! STENEX                                   
!     USE SUBST_COMM_MODULE          ! STENEX                                   
!     USE SUBST_UTIL_MODULE          ! STENEX  


      IMPLICIT NONE


C INCLUDES:                                                                     

!     INCLUDE SUBST_HGRD_ID     ! HORIZONTAL DIMENSIONING PARAMETERS            
!     INTEGER, PARAMETER :: NTHIK = 1                                           
!     INCLUDE SUBST_VGRD_ID     ! VERTICAL DIMENSIONING PARAMETERS              
!     INCLUDE SUBST_GC_ADV      ! GAS CHEM ADVECTION SPECIES AND MAP TABLE      
!     INCLUDE SUBST_AE_ADV      ! AEROSOL ADVECTION SPECIES AND MAP TABLE       
!     INCLUDE SUBST_NR_ADV      ! NON-REACT ADVECTION SPECIES AND MAP TABLE     
!     INCLUDE SUBST_TR_ADV      ! TRACER ADVECTION SPECIES AND MAP TABLE        
      INCLUDE SUBST_IOPARMS     ! I/O PARAMETERS DEFINITIONS                    
      INCLUDE SUBST_IODECL      ! I/O DEFINITIONS AND DECLARATIONS              
      INCLUDE SUBST_PE_COMM     ! PE COMMUNICATION DISPLACEMENT AND DIRECTION 

C==============================================
C DEFINE PARAMETERS                            
C==============================================
      REAL EPS
      PARAMETER ( EPS = 0.01 )
      REAL ETA1
      PARAMETER ( ETA1 = 20. )
      REAL ETA2
      PARAMETER ( ETA2 = 0.05 )
!      LOGICAL STEEPEN
!      PARAMETER ( STEEPEN =  .FALSE.  )

C FLAG FOR DISCONTINUTY CAPTURING (STEEPENING)                                  
#ifdef STEEPEN_FLAG
      LOGICAL, PARAMETER :: STEEPEN = .TRUE.
#else
      LOGICAL, PARAMETER :: STEEPEN = .FALSE.
#endif

      REAL TWO3RDS
      PARAMETER ( TWO3RDS = 2./3. )

C==============================================
C DEFINE COMMON BLOCKS
C==============================================
C$$$      COMMON /HPPMSV/ ALPHA, BETA, BNDY_HI_PE, BNDY_LO_PE, CHI, 
C$$$     $END1, END2, END3, FIRSTIME, 
C$$$     $FIRSTORI, LAMBDA, MNR, MU, MY_NI, NSPCS, NU, PSI, SIGMA, START1, 
C$$$     $START2, START3, TAU, XMSG, ZETA
C$$$      ALLOCATABLE ALPHA
C$$$      REAL ALPHA(:)
C$$$      ALLOCATABLE BETA
C$$$      REAL BETA(:)
C$$$      LOGICAL BNDY_HI_PE
C$$$      LOGICAL BNDY_LO_PE
C$$$      ALLOCATABLE CHI
C$$$      REAL CHI(:)
C$$$!      CHARACTER*(16)  :: DRCN_E = ' 0 0 1 0 0 0 0 0'
C$$$!      CHARACTER*(16)  :: DRCN_E_W = ' 0 0 1 0 0 0 1 0'
C$$$!      CHARACTER*(16)  :: DRCN_N = ' 1 0 0 0 0 0 0 0'
C$$$!      CHARACTER*(16)  :: DRCN_N_S = ' 1 0 0 0 1 0 0 0'
C$$$!      CHARACTER*(16)  :: DRCN_S = ' 0 0 0 0 1 0 0 0'
C$$$!      CHARACTER*(16)  :: DRCN_W = ' 0 0 0 0 0 0 1 0'
C$$$!      CHARACTER*(12)  :: DSPL_N0_E0_S0_W1 = '  0  0  0  1'
C$$$!      CHARACTER*(12)  :: DSPL_N0_E0_S1_W0 = '  0  0  1  0'
C$$$!      CHARACTER*(12)  :: DSPL_N0_E1_S0_W0 = '  0  1  0  0'
C$$$!      CHARACTER*(12)  :: DSPL_N0_E1_S0_W1 = '  0  1  0  1'
C$$$!      CHARACTER*(12)  :: DSPL_N1_E0_S0_W0 = '  1  0  0  0'
C$$$!      CHARACTER*(12)  :: DSPL_N1_E0_S1_W0 = '  1  0  1  0'
C$$$      INTEGER END1
C$$$      INTEGER END2
C$$$      INTEGER END3
C$$$      LOGICAL  :: FIRSTIME =  .TRUE. 
C$$$      CHARACTER  :: FIRSTORI = ' '
C$$$      ALLOCATABLE LAMBDA
C$$$      REAL LAMBDA(:)
C$$$      INTEGER MNR
C$$$      ALLOCATABLE MU
C$$$      REAL MU(:)
C$$$      INTEGER MY_NI
C$$$      INTEGER NSPCS
C$$$      ALLOCATABLE NU
C$$$      REAL NU(:)
C$$$      ALLOCATABLE PSI
C$$$      REAL PSI(:)
C$$$      ALLOCATABLE SIGMA
C$$$      REAL SIGMA(:)
C$$$      INTEGER START1
C$$$      INTEGER START2
C$$$      INTEGER START3
C$$$      ALLOCATABLE TAU
C$$$      REAL TAU(:)
C$$$      CHARACTER*(96)  :: XMSG = ' '
C$$$      ALLOCATABLE ZETA
C$$$      REAL ZETA(:)


      REAL, ALLOCATABLE, SAVE :: ALPHA ( : )
      REAL, ALLOCATABLE, SAVE :: BETA  ( : )
!     *END CHANGE BY SNL
      REAL, ALLOCATABLE, SAVE :: MU    ( : ) ! LATTICE VAR. FOR CM
      REAL, ALLOCATABLE, SAVE :: NU    ( : ) ! LATTICE VAR. FOR CM
      REAL, ALLOCATABLE, SAVE :: LAMBDA( : ) ! LATTICE VAR. FOR CM
      REAL, ALLOCATABLE, SAVE :: CHI   ( : ) ! LATTICE VAR. FOR DC
      REAL, ALLOCATABLE, SAVE :: PSI   ( : ) ! LATTICE VAR. FOR DC
      REAL, ALLOCATABLE, SAVE :: ZETA  ( : ) ! LATTICE VAR. FOR ETABAR
      REAL, ALLOCATABLE, SAVE :: SIGMA ( : ) ! LATTICE VAR. FOR D2C
      REAL, ALLOCATABLE, SAVE :: TAU   ( : ) ! LATTICE VAR. FOR D2C

      INTEGER, SAVE :: MY_NI
      INTEGER, SAVE :: START1, END1
      INTEGER, SAVE :: START2, END2
      INTEGER, SAVE :: START3, END3
      INTEGER, SAVE :: NSPCS
      INTEGER, SAVE :: MNR
      LOGICAL, SAVE :: BNDY_LO_PE, BNDY_HI_PE
      CHARACTER( 96 ) :: XMSG = ' '

      CHARACTER, SAVE :: FIRSTORI = ' '
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      
C==============================================
C DEFINE ARGUMENTS
C==============================================
      REAL ADCONI(:,:)
      REAL CONI(:,:)
      REAL DSI(:)
      REAL DT
      INTEGER NI
      CHARACTER ORI
      REAL VEL(:)

C==============================================
C DEFINE LOCAL VARIABLES
C==============================================
      REAL A
      REAL ADC6(NI,SIZE(CONI,2))
      REAL ADCL(NI,SIZE(CONI,2))
      REAL ADCLD(NI,SIZE(CONI,2))
      REAL ADCM(NI+1,SIZE(CONI,2))
      REAL ADCON(0:NI+1,SIZE(CONI,2))
      REAL ADCR(NI,SIZE(CONI,2))
      REAL ADCRD(NI,SIZE(CONI,2))
      REAL ADD2C(0:NI+1,SIZE(CONI,2))
      REAL ADDC(0:NI+1,SIZE(CONI,2))
      REAL ADETA(NI,SIZE(CONI,2))
      REAL ADETABAR(NI,SIZE(CONI,2))
      REAL ADFM(NI+1,SIZE(CONI,2))
      REAL ADFP(0:NI,SIZE(CONI,2))
      REAL B
      REAL C
      REAL C6(NI,SIZE(CONI,2))
      REAL CL(NI,SIZE(CONI,2))
      REAL CLD(NI,SIZE(CONI,2))
      REAL CM(NI+1,SIZE(CONI,2))
      REAL CON(0:NI+1,SIZE(CONI,2))
      REAL CONIH(0:NI+1,SIZE(CONI,2))
      REAL CONII(0:NI+1,SIZE(CONI,2))
      REAL CR(NI,SIZE(CONI,2))
      REAL CRD(NI,SIZE(CONI,2))
      REAL D
      REAL D2C(0:NI+1,SIZE(CONI,2))
      REAL DC(0:NI+1,SIZE(CONI,2))
      REAL DS(-1:NI+1)
      REAL ETA(NI,SIZE(CONI,2))
      REAL ETABAR(NI,SIZE(CONI,2))
      REAL FM(NI+1,SIZE(CONI,2))
      REAL FP(0:NI,SIZE(CONI,2))
      REAL GAMMA
      INTEGER I
      INTEGER S
      REAL X
      REAL Y
      INTEGER :: ALLOCSTAT

C----------------------------------------------
C SAVE ARGUMENTS
C----------------------------------------------
      CONIH(:,:) = CONI(:,:)

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      ADC6(:,:) = 0.
      ADCL(:,:) = 0.
      ADCLD(:,:) = 0.
      ADCM(:,:) = 0.
      ADCON(:,:) = 0.
      ADCR(:,:) = 0.
      ADCRD(:,:) = 0.
      ADD2C(:,:) = 0.
      ADDC(:,:) = 0.
      ADETA(:,:) = 0.
      ADETABAR(:,:) = 0.
      ADFM(:,:) = 0.
      ADFP(:,:) = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      DO I = -1, NI+1
        DS(I) = DSI(I+2)
      END DO  

    
      IF (ORI .NE. FIRSTORI) THEN

        FIRSTORI = ORI
        NSPCS = SIZE(CONI,2)
        MNR   = MAX( NCOLS, NROWS )
        
        CALL SUBST_LOOP_INDEX ( ORI, 2, NI, -1, MY_NI, START1, END1 )
        CALL SUBST_LOOP_INDEX ( ORI, 3, NI, -1, MY_NI, START2, END2 )
        CALL SUBST_LOOP_INDEX ( ORI, 3, NI, -2, MY_NI, START3, END3 )
        
        CALL SUBST_HI_LO_BND_PE ( ORI, BNDY_LO_PE, BNDY_HI_PE )
              
        IF ( FIRSTIME ) THEN
           FIRSTIME = .FALSE.
!     LOGDEV = INIT3()

!*BEGIN CHANGE BY SNL
           ALLOCATE ( ALPHA ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( BETA  ( MNR ), STAT = ALLOCSTAT )
!*END CHANGE BY SNL
           ALLOCATE ( MU    ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( NU    ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( LAMBDA( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( CHI   ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( PSI   ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( ZETA  ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( SIGMA ( MNR ), STAT = ALLOCSTAT )
           ALLOCATE ( TAU   ( MNR ), STAT = ALLOCSTAT )
            
           IF ( ALLOCSTAT .NE. 0 ) THEN
              XMSG = 'FAILURE ALLOCATING LATTICE VARIABLE(S)'
              CALL M3EXIT ( 'HPPM', 0, 0, XMSG, XSTAT1 )
           END IF
        END IF
                  
        DO I = START1, END1
          ALPHA(I) = DS(I)+DS(I+1)
          BETA(I) = DS(I-1)+DS(I)
          GAMMA = DS(I-2)+DS(I-1)
          D = DS(I)/(BETA(I)+DS(I+1))
          CHI(I) = D*(DS(I-1)+BETA(I))/ALPHA(I)
          PSI(I) = D*(ALPHA(I)+DS(I+1))/BETA(I)
          A = DS(I-1)/BETA(I)
          B = 2.*DS(I)/BETA(I)
          C = 1./(ALPHA(I)+GAMMA)
          MU(I) = C*DS(I-1)*GAMMA/(DS(I-1)+BETA(I))
          NU(I) = C*DS(I)*ALPHA(I)/(DS(I)+BETA(I))
          LAMBDA(I) = A+MU(I)*B-2.*NU(I)*A
        END DO
        IF (STEEPEN) THEN
          DO I = START1, END1
            C = 1./(BETA(I)+DS(I+1))
            SIGMA(I) = C/ALPHA(I)
            TAU(I) = C/BETA(I)
            ZETA(I) = 0.25*(ALPHA(I)*ALPHA(I)-ALPHA(I)*BETA(I)+BETA(I)*
     $BETA(I))
          END DO
        ENDIF
      ENDIF   !FIRSTORI
      DO I = 0, NI+1
        CON(I,:) = CONI(I+1,:)
      END DO
      DO S = 1, NSPCS
        FP(0,S) = 0.
        DO I = 1, NI
          FM(I,S) = 0.
          FP(I,S) = 0.
        END DO
        FM(NI+1,S) = 0.
      END DO
      IF (BNDY_LO_PE) THEN
        DO S = 1, NSPCS
          CM(1,S) = CON(1,S)
          CM(2,S) = (DS(1)*CON(2,S)+DS(2)*CON(1,S))/(DS(1)+DS(2))
        END DO
      ENDIF
      IF (BNDY_HI_PE) THEN
        DO S = 1, NSPCS
          CM(MY_NI+1,S) = CON(MY_NI,S)
          CM(MY_NI,S) = (DS(MY_NI-1)*CON(MY_NI,S)+DS(MY_NI)*CON(MY_NI-1,
     $S))/(DS(MY_NI-1)+DS(MY_NI))
        END DO
      ENDIF
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( CON,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
      ELSE
        CALL SUBST_COMM( CON,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
      ENDIF
     
      DO S = 1, NSPCS
        DO I = START1, END1
          DC(I,S) = CHI(I)*(CON(I+1,S)-CON(I,S))+PSI(I)*(CON(I,S)-CON(I-
     $1,S))
          IF ((CON(I+1,S)-CON(I,S))*(CON(I,S)-CON(I-1,S)) .GT. 0.) THEN
            DC(I,S) = SIGN(1.,DC(I,S))*MIN(ABS(DC(I,S)),2.*ABS(CON(I+1,
     $S)-CON(I,S)),2.*ABS(CON(I,S)-CON(I-1,S)))
          ELSE
            DC(I,S) = 0.
          ENDIF
        END DO   ! I
      END DO   ! S
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( DC,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
      ELSE
        CALL SUBST_COMM( DC,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
      ENDIF

      DO S = 1, NSPCS
        DO I = START2, END2
          CM(I,S) = CON(I-1,S)+LAMBDA(I)*(CON(I,S)-CON(I-1,S))-MU(I)*
     $DC(I,S)+NU(I)*DC(I-1,S)
        END DO
        DO I = 1, NI
          ETA(I,S) = 0.
          CLD(I,S) = CON(I,S)
          CRD(I,S) = CON(I,S)
        END DO
      END DO
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( CM,DSPL_N1_E0_S0_W0,DRCN_N,1 )
      ELSE
        CALL SUBST_COMM( CM,DSPL_N0_E1_S0_W0,DRCN_E,1 )
      ENDIF

    
      IF (STEEPEN) THEN
        DO S = 1, NSPCS
          DO I = START1, END1
            D2C(I,S) = SIGMA(I)*(CON(I+1,S)-CON(I,S))-TAU(I)*(CON(I,S)-
     $CON(I-1,S))
          END DO
        END DO
        IF (ORI .EQ. 'R') THEN
         CALL SUBST_COMM( D2C,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
        ELSE
          CALL SUBST_COMM( D2C,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
        ENDIF
        DO S = 1, NSPCS
          DO I = START3, END3
            IF ((-(D2C(I+1,S)*D2C(I-1,S))) .GT. 0. .AND. ABS(CON(I+1,S)-
     $CON(I-1,S))-EPS*MIN(ABS(CON(I+1,S)),ABS(CON(I-1,S))) .GT. 0.) THEN
              ETABAR(I,S) = -(ZETA(I)*(D2C(I+1,S)-D2C(I-1,S))/(CON(I+1,
     $S)-CON(I-1,S)))
            ELSE
              ETABAR(I,S) = 0.
            ENDIF
            ETA(I,S) = MAX(0.,MIN(ETA1*(ETABAR(I,S)-ETA2),1.))
            CRD(I,S) = CON(I+1,S)-0.5*DC(I+1,S)
            CLD(I,S) = CON(I-1,S)+0.5*DC(I-1,S)
          END DO
        END DO
      ENDIF
     
      
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( VEL,DSPL_N1_E0_S0_W0,DRCN_N )
      ELSE
       CALL SUBST_COMM( VEL,DSPL_N0_E1_S0_W0,DRCN_E )
      ENDIF
      
 

      DO S = 1, NSPCS
        DO I = 1, MY_NI
          CR(I,S) = CM(I+1,S)+ETA(I,S)*(CRD(I,S)-CM(I+1,S))
          CL(I,S) = CM(I,S)+ETA(I,S)*(CLD(I,S)-CM(I,S))
          IF ((CR(I,S)-CON(I,S))*(CON(I,S)-CL(I,S)) .GT. 0.) THEN
            DC(I,S) = CR(I,S)-CL(I,S)
            C6(I,S) = 6.*(CON(I,S)-0.5*(CL(I,S)+CR(I,S)))
            IF (DC(I,S)*C6(I,S) .GT. DC(I,S)*DC(I,S)) THEN
              CL(I,S) = 3.*CON(I,S)-2.*CR(I,S)
            ELSE IF ((-(DC(I,S)*DC(I,S))) .GT. DC(I,S)*C6(I,S)) THEN
              CR(I,S) = 3.*CON(I,S)-2.*CL(I,S)
            ENDIF
          ELSE
            CL(I,S) = CON(I,S)
            CR(I,S) = CON(I,S)
          ENDIF
          DC(I,S) = CR(I,S)-CL(I,S)
          C6(I,S) = 6.*(CON(I,S)-0.5*(CL(I,S)+CR(I,S)))
        END DO
        DO I = 1, MY_NI
          IF (VEL(I) .LT. 0.) THEN
            Y = -(VEL(I)*DT)
            X = Y/DS(I)
            FM(I,S) = Y*(CL(I,S)+0.5*X*(DC(I,S)+C6(I,S)*(1.-TWO3RDS*X)))
          ENDIF
          IF (VEL(I+1) .GT. 0.) THEN
            Y = VEL(I+1)*DT
            X = Y/DS(I)
            FP(I,S) = Y*(CR(I,S)-0.5*X*(DC(I,S)-C6(I,S)*(1.-TWO3RDS*X)))
          ENDIF
        END DO
      END DO
      IF (BNDY_LO_PE) THEN
        IF (VEL(1) .GT. 0.) THEN
          DO S = 1, NSPCS
            Y = VEL(1)*DT
            FP(0,S) = Y*CON(0,S)
          END DO
        ENDIF
      ENDIF
      IF (BNDY_HI_PE) THEN
        IF (VEL(NI+1) .LT. 0.) THEN
          DO S = 1, NSPCS
            Y = -(VEL(NI+1)*DT)
            FM(NI+1,S) = Y*CON(NI+1,S)
          END DO
        ENDIF
      ENDIF
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( FP,DSPL_N0_E0_S1_W0,DRCN_S,1,'1 0' )
        CALL SUBST_COMM( FM,DSPL_N1_E0_S0_W0,DRCN_N,1 )
      ELSE
        CALL SUBST_COMM( FP,DSPL_N0_E0_S0_W1,DRCN_W,1,'1 0' )
        CALL SUBST_COMM( FM,DSPL_N0_E1_S0_W0,DRCN_E,1 )
      ENDIF
      DO S = 1, NSPCS
        DO I = 1, MY_NI
          CON(I,S) = CON(I,S)+(FP(I-1,S)-FP(I,S)+FM(I+1,S)-FM(I,S))/
     $DS(I)
        END DO
      END DO
      DO I = 0, NI+1
        CONI(I+1,:) = CON(I,:)
      END DO

C----------------------------------------------
C SAVE DEPENDEND VARIABLES
C----------------------------------------------
      CONII(:,:) = CONI(:,:)
C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      DO I = 0, NI+1
        CON(I,:) = CONI(I+1,:)
      END DO
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( CON,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
      ELSE
        CALL SUBST_COMM( CON,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
      ENDIF

      DO I = 0, NI+1
        ADCON(I,:) = ADCON(I,:)+ADCONI(I+1,:)
        ADCONI(I+1,:) = 0.
      END DO
 
      DO S = 1, NSPCS
        DO I = 1, MY_NI
          ADFM(I+1,S) = ADFM(I+1,S)+ADCON(I,S)/DS(I)
          ADFM(I,S) = ADFM(I,S)-ADCON(I,S)/DS(I)
          ADFP(I-1,S) = ADFP(I-1,S)+ADCON(I,S)/DS(I)
          ADFP(I,S) = ADFP(I,S)-ADCON(I,S)/DS(I)
        END DO
      END DO
      
      IF ( ORI .EQ. 'R' ) THEN
         CALL SUBST_COMM ( ADFP, DSPL_N0_E0_S1_W0, DRCN_S, 1, '1 0' )
         CALL SUBST_COMM ( ADFM, DSPL_N1_E0_S0_W0, DRCN_N, 1 )
      ELSE
         CALL SUBST_COMM ( ADFP, DSPL_N0_E0_S0_W1, DRCN_W, 1, '1 0' )
         CALL SUBST_COMM ( ADFM, DSPL_N0_E1_S0_W0, DRCN_E, 1 )
      END IF

     
      IF (BNDY_HI_PE) THEN
        IF (VEL(NI+1) .LT. 0.) THEN
          DO S = 1, NSPCS
            Y = -(VEL(NI+1)*DT)
            ADCON(NI+1,S) = ADCON(NI+1,S)+ADFM(NI+1,S)*Y
            ADFM(NI+1,S) = 0.
          END DO
        ENDIF
      ENDIF
 
      IF (BNDY_LO_PE) THEN
        IF (VEL(1) .GT. 0.) THEN
          DO S = 1, NSPCS
            Y = VEL(1)*DT
            ADCON(0,S) = ADCON(0,S)+ADFP(0,S)*Y
            ADFP(0,S) = 0.
          END DO
        ENDIF
      ENDIF
 

      CONI(:,:) = CONIH(:,:)
      DO I = 0, NI+1
        CON(I,:) = CONI(I+1,:)
      END DO


      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( CON,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
      ELSE
        CALL SUBST_COMM( CON,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
      ENDIF
      
      DO S = NSPCS, 1, -1
        DO I = MY_NI, 1, -1
          IF (VEL(I+1) .GT. 0.) THEN
            Y = VEL(I+1)*DT
            X = Y/DS(I)
            ADC6(I,S) = ADC6(I,S)+0.5*ADFP(I,S)*Y*X*(1.-TWO3RDS*X)
            ADCR(I,S) = ADCR(I,S)+ADFP(I,S)*Y
            ADDC(I,S) = ADDC(I,S)-0.5*ADFP(I,S)*Y*X
            ADFP(I,S) = 0.
          ENDIF
          IF (VEL(I) .LT. 0.) THEN
            Y = -(VEL(I)*DT)
            X = Y/DS(I)
            ADC6(I,S) = ADC6(I,S)+0.5*ADFM(I,S)*Y*X*(1.-TWO3RDS*X)
            ADCL(I,S) = ADCL(I,S)+ADFM(I,S)*Y
            ADDC(I,S) = ADDC(I,S)+0.5*ADFM(I,S)*Y*X
            ADFM(I,S) = 0.
          ENDIF
        END DO
        DO I = 1, MY_NI
          CR(I,S) = CM(I+1,S)+ETA(I,S)*(CRD(I,S)-CM(I+1,S))
          CL(I,S) = CM(I,S)+ETA(I,S)*(CLD(I,S)-CM(I,S))
          ADCL(I,S) = ADCL(I,S)-3*ADC6(I,S)
          ADCON(I,S) = ADCON(I,S)+6*ADC6(I,S)
          ADCR(I,S) = ADCR(I,S)-3*ADC6(I,S)
          ADC6(I,S) = 0.
          ADCL(I,S) = ADCL(I,S)-ADDC(I,S)
          ADCR(I,S) = ADCR(I,S)+ADDC(I,S)
          ADDC(I,S) = 0.
          IF ((CR(I,S)-CON(I,S))*(CON(I,S)-CL(I,S)) .GT. 0.) THEN
            DC(I,S) = CR(I,S)-CL(I,S)
            C6(I,S) = 6.*(CON(I,S)-0.5*(CL(I,S)+CR(I,S)))
            IF (DC(I,S)*C6(I,S) .GT. DC(I,S)*DC(I,S)) THEN
              ADCON(I,S) = ADCON(I,S)+3*ADCL(I,S)
              ADCR(I,S) = ADCR(I,S)-2*ADCL(I,S)
              ADCL(I,S) = 0.
            ELSE IF ((-(DC(I,S)*DC(I,S))) .GT. DC(I,S)*C6(I,S)) THEN
              ADCL(I,S) = ADCL(I,S)-2*ADCR(I,S)
              ADCON(I,S) = ADCON(I,S)+3*ADCR(I,S)
              ADCR(I,S) = 0.
            ENDIF
            ADCL(I,S) = ADCL(I,S)-3*ADC6(I,S)
            ADCON(I,S) = ADCON(I,S)+6*ADC6(I,S)
            ADCR(I,S) = ADCR(I,S)-3*ADC6(I,S)
            ADC6(I,S) = 0.
            ADCL(I,S) = ADCL(I,S)-ADDC(I,S)
            ADCR(I,S) = ADCR(I,S)+ADDC(I,S)
            ADDC(I,S) = 0.
          ELSE
            ADCON(I,S) = ADCON(I,S)+ADCR(I,S)
            ADCR(I,S) = 0.
            ADCON(I,S) = ADCON(I,S)+ADCL(I,S)
            ADCL(I,S) = 0.
          ENDIF
          ADCLD(I,S) = ADCLD(I,S)+ADCL(I,S)*ETA(I,S)
          ADCM(I,S) = ADCM(I,S)+ADCL(I,S)*(1-ETA(I,S))
          ADETA(I,S) = ADETA(I,S)+ADCL(I,S)*(CLD(I,S)-CM(I,S))
          ADCL(I,S) = 0.
          ADCM(I+1,S) = ADCM(I+1,S)+ADCR(I,S)*(1-ETA(I,S))
          ADCRD(I,S) = ADCRD(I,S)+ADCR(I,S)*ETA(I,S)
          ADETA(I,S) = ADETA(I,S)+ADCR(I,S)*(CRD(I,S)-CM(I+1,S))
          ADCR(I,S) = 0.
        END DO
      END DO

      IF ( ORI .EQ. 'R' ) THEN
         CALL SUBST_COMM ( VEL, DSPL_N1_E0_S0_W0, DRCN_N )
      ELSE
         CALL SUBST_COMM ( VEL, DSPL_N0_E1_S0_W0, DRCN_E )
      END IF



      IF (STEEPEN) THEN
        DO S = 1, NSPCS
          DO I = START3, END3
            IF ((-(D2C(I+1,S)*D2C(I-1,S))) .GT. 0. .AND. ABS(CON(I+1,S)-
     $CON(I-1,S))-EPS*MIN(ABS(CON(I+1,S)),ABS(CON(I-1,S))) .GT. 0.) THEN
              ETABAR(I,S) = -(ZETA(I)*(D2C(I+1,S)-D2C(I-1,S))/(CON(I+1,
     $S)-CON(I-1,S)))
            ELSE
              ETABAR(I,S) = 0.
            ENDIF
            ADCON(I-1,S) = ADCON(I-1,S)+ADCLD(I,S)
            ADDC(I-1,S) = ADDC(I-1,S)+0.5*ADCLD(I,S)
            ADCLD(I,S) = 0.
            ADCON(I+1,S) = ADCON(I+1,S)+ADCRD(I,S)
            ADDC(I+1,S) = ADDC(I+1,S)-0.5*ADCRD(I,S)
            ADCRD(I,S) = 0.
            ADETABAR(I,S) = ADETABAR(I,S)+ADETA(I,S)*(0.5-SIGN(0.5,0.-
     $MIN(ETA1*(ETABAR(I,S)-ETA2),1.)))*(0.5+SIGN(0.5,1.-ETA1*(ETABAR(I,
     $S)-ETA2)))*ETA1
            ADETA(I,S) = 0.
            IF ((-(D2C(I+1,S)*D2C(I-1,S))) .GT. 0. .AND. ABS(CON(I+1,S)-
     $CON(I-1,S))-EPS*MIN(ABS(CON(I+1,S)),ABS(CON(I-1,S))) .GT. 0.) THEN
              ADCON(I-1,S) = ADCON(I-1,S)-ADETABAR(I,S)*(ZETA(I)*(D2C(I+
     $1,S)-D2C(I-1,S))/((CON(I+1,S)-CON(I-1,S))*(CON(I+1,S)-CON(I-1,S)))
     $)
              ADCON(I+1,S) = ADCON(I+1,S)+ADETABAR(I,S)*(ZETA(I)*(D2C(I+
     $1,S)-D2C(I-1,S))/((CON(I+1,S)-CON(I-1,S))*(CON(I+1,S)-CON(I-1,S)))
     $)
              ADD2C(I-1,S) = ADD2C(I-1,S)+ADETABAR(I,S)*(ZETA(I)/(CON(I+
     $1,S)-CON(I-1,S)))
              ADD2C(I+1,S) = ADD2C(I+1,S)-ADETABAR(I,S)*(ZETA(I)/(CON(I+
     $1,S)-CON(I-1,S)))
              ADETABAR(I,S) = 0.
            ELSE
              ADETABAR(I,S) = 0.
            ENDIF
          END DO
        END DO

        IF ( ORI .EQ. 'R' ) THEN

            CALL SUBST_COMM ( ADD2C, DSPL_N1_E0_S1_W0, DRCN_N_S, 1, '1 0' )       
        ELSE
            CALL SUBST_COMM ( ADD2C, DSPL_N0_E1_S0_W1, DRCN_E_W, 1, '1 0' )       
        END IF


        DO S = 1, NSPCS
          DO I = START1, END1
            ADCON(I-1,S) = ADCON(I-1,S)+ADD2C(I,S)*TAU(I)
            ADCON(I+1,S) = ADCON(I+1,S)+ADD2C(I,S)*SIGMA(I)
            ADCON(I,S) = ADCON(I,S)-ADD2C(I,S)*(SIGMA(I)+TAU(I))
            ADD2C(I,S) = 0.
          END DO
        END DO
      ENDIF

      IF ( ORI .EQ. 'R' ) THEN
         CALL SUBST_COMM ( ADCM, DSPL_N1_E0_S0_W0, DRCN_N, 1 )
      ELSE
         CALL SUBST_COMM ( ADCM, DSPL_N0_E1_S0_W0, DRCN_E, 1 )
      END IF

      DO S = 1, NSPCS
        DO I = 1, NI
          ADCON(I,S) = ADCON(I,S)+ADCRD(I,S)
          ADCRD(I,S) = 0.
          ADCON(I,S) = ADCON(I,S)+ADCLD(I,S)
          ADCLD(I,S) = 0.
        END DO
        DO I = START2, END2
          ADCON(I-1,S) = ADCON(I-1,S)+ADCM(I,S)*(1-LAMBDA(I))
          ADCON(I,S) = ADCON(I,S)+ADCM(I,S)*LAMBDA(I)
          ADDC(I-1,S) = ADDC(I-1,S)+ADCM(I,S)*NU(I)
          ADDC(I,S) = ADDC(I,S)-ADCM(I,S)*MU(I)
          ADCM(I,S) = 0.
        END DO
      END DO
!*BEGIN CHANGE BY SNL                                                           
C UPDATE THE DC ARRAY WITH OFF-PE DATA, IF NEC.                                
      IF ( ORI .EQ. 'R' ) THEN
         CALL SUBST_COMM ( ADDC, DSPL_N1_E0_S1_W0, DRCN_N_S, 1, '1 0' )
      ELSE
         CALL SUBST_COMM ( ADDC, DSPL_N0_E1_S0_W1, DRCN_E_W, 1, '1 0' )
      END IF
!*END CHANGE BY SNL  

      DO S = 1, NSPCS
        DO I = START1, END1
          DC(I,S) = CHI(I)*(CON(I+1,S)-CON(I,S))+PSI(I)*(CON(I,S)-CON(I-
     $1,S))
          IF ((CON(I+1,S)-CON(I,S))*(CON(I,S)-CON(I-1,S)) .GT. 0.) THEN
            ADCON(I+1,S) = ADCON(I+1,S)+2.*ADDC(I,S)*(0.5-SIGN(0.5,2.*
     $ABS(CON(I+1,S)-CON(I,S))-ABS(DC(I,S))))*SIGN(1.,CON(I+1,S)-CON(I,
     $S))*SIGN(1.,DC(I,S))
            ADCON(I,S) = ADCON(I,S)-2.*ADDC(I,S)*(0.5-SIGN(0.5,2.*
     $ABS(CON(I+1,S)-CON(I,S))-ABS(DC(I,S))))*SIGN(1.,CON(I+1,S)-CON(I,
     $S))*SIGN(1.,DC(I,S))
            ADDC(I,S) = ADDC(I,S)*(0.5+SIGN(0.5,2.*ABS(CON(I+1,S)-CON(I,
     $S))-ABS(DC(I,S))))*SIGN(1.,DC(I,S))*SIGN(1.,DC(I,S))
          ELSE
            ADDC(I,S) = 0.
          ENDIF
          ADCON(I-1,S) = ADCON(I-1,S)-ADDC(I,S)*PSI(I)
          ADCON(I+1,S) = ADCON(I+1,S)+ADDC(I,S)*CHI(I)
          ADCON(I,S) = ADCON(I,S)+ADDC(I,S)*((-CHI(I))+PSI(I))
          ADDC(I,S) = 0.
        END DO
      END DO
      IF (ORI .EQ. 'R') THEN
        CALL SUBST_COMM( ADCON,DSPL_N1_E0_S1_W0,DRCN_N_S,1,'1 0' )
      ELSE
        CALL SUBST_COMM( ADCON,DSPL_N0_E1_S0_W1,DRCN_E_W,1,'1 0' )
      ENDIF

      IF (BNDY_HI_PE) THEN
        DO S = 1, NSPCS
          ADCON(MY_NI-1,S) = ADCON(MY_NI-1,S)+ADCM(MY_NI,S)*(DS(MY_NI)/
     $(DS(MY_NI-1)+DS(MY_NI)))
          ADCON(MY_NI,S) = ADCON(MY_NI,S)+ADCM(MY_NI,S)*(DS(MY_NI-1)/
     $(DS(MY_NI-1)+DS(MY_NI)))
          ADCM(MY_NI,S) = 0.
          ADCON(MY_NI,S) = ADCON(MY_NI,S)+ADCM(MY_NI+1,S)
          ADCM(MY_NI+1,S) = 0.
        END DO
      ENDIF
      IF (BNDY_LO_PE) THEN
        DO S = 1, NSPCS
          ADCON(2,S) = ADCON(2,S)+ADCM(2,S)*(DS(1)/(DS(1)+DS(2)))
          ADCON(1,S) = ADCON(1,S)+ADCM(2,S)*(DS(2)/(DS(1)+DS(2)))
          ADCM(2,S) = 0.
          ADCON(1,S) = ADCON(1,S)+ADCM(1,S)
          ADCM(1,S) = 0.
        END DO
      ENDIF
      DO I = 0, NI+1
        ADCONI(I+1,:) = ADCONI(I+1,:)+ADCON(I,:)
        ADCON(I,:) = 0.
      END DO

C----------------------------------------------
C GET DEPENDEND VARIABLES
C----------------------------------------------
      CONI(:,:) = CONII(:,:)

!      PRINT*,'---------------------------'
!      PRINT*,'AFTER THE END'
!      PRINT*,'---------------------------'

      END SUBROUTINE ADHPPM


