C                           DISCLAIMER
C
C   THIS FILE WAS GENERATED BY TAMC VERSION 5.3.2
C
C   THE AUTHOR DOES NOT MAKE  ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES
C   ANY LEGAL LIABILITY OR  RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS,
C   OR USEFULNESS  OF ANY INFORMATION OR PROCESS  DISCLOSED, OR REPRESENTS
C   THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
C
C   THIS CODE IS FOR NON-PROFIT-ORIENTED ACADEMIC RESEARCH AND EDUCATION
C   ONLY.  ANY COMMERCIAL OR OTHER PROFIT-ORIENTED USE OR  EVALUATION IS
C   STRICTLY  FORBIDDEN.  PASSING  THIS CODE  TO  ANY THIRD  PARTY IS  NOT
C   ALLOWED.
C
C   FOR COMMERCIAL OR  OTHER PROFIT-ORIENTED APPLICATIONS PLEASE CONTACT
C   INFO@FASTOPT.COM
C
      SUBROUTINE ADVPPM( NI, CON, VEL, DT, DS, ADCON )
C***************************************************************
C***************************************************************
C** THIS ROUTINE WAS GENERATED BY THE                         **
C** TANGENT LINEAR AND ADJOINT MODEL COMPILER,  TAMC 5.3.2    **
C***************************************************************
C***************************************************************
C==============================================
C ALL ENTRIES ARE DEFINED EXPLICITLY
C==============================================
      USE VGRD_DEFN 
     
      IMPLICIT NONE
      

      INCLUDE SUBST_IOPARMS     ! I/O PARAMETERS DEFINITIONS
      INCLUDE SUBST_IODECL      ! I/O DEFINITIONS AND DECLARATIONS
C==============================================
C DEFINE PARAMETERS                            
C==============================================
      REAL EPS
      PARAMETER ( EPS = 0.01 )
      REAL ETA1
      PARAMETER ( ETA1 = 20. )
      REAL ETA2
      PARAMETER ( ETA2 = 1./ETA1 )
      LOGICAL STEEPEN
      PARAMETER ( STEEPEN =  .TRUE.  )
      REAL TWO3RDS
      PARAMETER ( TWO3RDS = 2./3. )

C==============================================
C DEFINE COMMON BLOCKS
C==============================================
C$$$      COMMON /VPPMSV/ CHI, FIRSTIME, LAMBDA, LOGDEV, MU, NU, PSI, SIGMA,
C$$$     $ TAU, XMSG, ZETA
C$$$      ALLOCATABLE CHI
C$$$      REAL CHI(:)
C$$$      LOGICAL  :: FIRSTIME =  .TRUE. 
C$$$      ALLOCATABLE LAMBDA
C$$$      REAL LAMBDA(:)
C$$$      INTEGER LOGDEV
C$$$      ALLOCATABLE MU
C$$$      REAL MU(:)
C$$$      ALLOCATABLE NU
C$$$      REAL NU(:)
C$$$      ALLOCATABLE PSI
C$$$      REAL PSI(:)
C$$$      ALLOCATABLE SIGMA
C$$$      REAL SIGMA(:)
C$$$      ALLOCATABLE TAU
C$$$      REAL TAU(:)
C$$$      CHARACTER*(120)  :: XMSG = ' '
C$$$      ALLOCATABLE ZETA
C$$$      REAL ZETA(:)

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      REAL, ALLOCATABLE, SAVE :: MU( : )
      REAL, ALLOCATABLE, SAVE :: NU    ( : )  ! LATTICE VAR. FOR CM
      REAL, ALLOCATABLE, SAVE :: LAMBDA( : )  ! LATTICE VAR. FOR CM
      REAL, ALLOCATABLE, SAVE :: CHI   ( : )  ! LATTICE VAR. FOR DC
      REAL, ALLOCATABLE, SAVE :: PSI   ( : )  ! LATTICE VAR. FOR DC
      REAL, ALLOCATABLE, SAVE :: ZETA  ( : )  ! LATTICE VAR. FOR ETABAR
      REAL, ALLOCATABLE, SAVE :: SIGMA ( : )  ! LATTICE VAR. FOR D2C
      REAL, ALLOCATABLE, SAVE :: TAU   ( : )  ! LATTICE VAR. FOR D2C
      CHARACTER( 120 ) :: XMSG = ' '
      INTEGER, SAVE :: LOGDEV

C==============================================
C DEFINE ARGUMENTS
C==============================================
      INTEGER NI
      REAL ADCON(NI)
      REAL CON(NI)
      REAL DS(NI)
      REAL DT
      REAL VEL(NI)
  
C==============================================
C DEFINE LOCAL VARIABLES
C==============================================
      REAL A
      REAL ADC6(NLAYS+1)
      REAL ADCL(NLAYS+1)
      REAL ADCLD(NLAYS+1)
      REAL ADCM(0:NLAYS+1)
      REAL ADCR(NLAYS+1)
      REAL ADCRD(NLAYS+1)
      REAL ADD2C(NLAYS+1)
      REAL ADDC(NLAYS+1)
      REAL ADETA(NLAYS+1)
      REAL ADETABAR(NLAYS+1)
      REAL ADFM(0:NLAYS+1)
      REAL ADFP(0:NLAYS+1)
      REAL ALPHA(NLAYS+1)
      REAL B
      REAL BETA(NLAYS+1)
      REAL C
      REAL C6(NLAYS+1)
      REAL CL(NLAYS+1)
      REAL CLD(NLAYS+1)
      REAL CM(0:NLAYS+1)
      REAL CONH(NI)
      REAL CONI(NI)
      REAL CR(NLAYS+1)
      REAL CRD(NLAYS+1)
      REAL D2C(NLAYS+1)
      REAL DC(NLAYS+1)
      REAL ETA(NLAYS+1)
      REAL ETABAR(NLAYS+1)
      REAL FM(0:NLAYS+1)
      REAL FP(0:NLAYS+1)
      REAL X                    ! COURANT NUMBER
      REAL Y
      
      INTEGER I                 ! LOOP INDEX

      INTEGER ALLOCSTAT
C==============================================
C DEFINE EXTERNAL PROCEDURES AND FUNCTIONS
C==============================================
      !INTEGER INIT3
      !EXTERNAL INIT3

C----------------------------------------------
C SAVE ARGUMENTS
C----------------------------------------------
      CONH(:) = CON(:)

C----------------------------------------------
C RESET LOCAL ADJOINT VARIABLES
C----------------------------------------------
      ADC6(:) = 0.
      ADCL(:) = 0.
      ADCLD(:) = 0.
      ADCM(:) = 0.
      ADCR(:) = 0.
      ADCRD(:) = 0.
      ADD2C(:) = 0.
      ADDC(:) = 0.
      ADETA(:) = 0.
      ADETABAR(:) = 0.
      ADFM(:) = 0.
      ADFP(:) = 0.

C----------------------------------------------
C ROUTINE BODY
C----------------------------------------------
C----------------------------------------------
C FUNCTION AND TAPE COMPUTATIONS
C----------------------------------------------
      IF (FIRSTIME) THEN
         FIRSTIME = .FALSE.
         LOGDEV = INIT3 ()

         ALLOCATE ( MU    ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( NU    ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( LAMBDA( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( CHI   ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( PSI   ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( ZETA  ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( SIGMA ( NLAYS+1 ), STAT = ALLOCSTAT )
         ALLOCATE ( TAU   ( NLAYS+1 ), STAT = ALLOCSTAT )

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'FAILURE ALLOCATING '
     &           // 'MU, NU, LAMBDA, CHI, PSI, ZETA, SIGMA, OR TAU'
            CALL M3EXIT( 'VPPM', 0, 0, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,* ) '   VPPM STEEPEN: ', STEEPEN
         
        DO I = 2, NI-1
          ALPHA(I) = DS(I)+DS(I+1)
          BETA(I) = DS(I-1)+DS(I)
          C = DS(I)/(BETA(I)+DS(I+1))
          CHI(I) = C*(DS(I-1)+BETA(I))/ALPHA(I)
          PSI(I) = C*(ALPHA(I)+DS(I+1))/BETA(I)
        END DO
        DO I = 2, NI-2
          A = DS(I)/ALPHA(I)
          B = 2.*DS(I+1)/ALPHA(I)
          C = 1./(DS(I-1)+ALPHA(I)+DS(I+2))
          MU(I) = C*DS(I)*(DS(I-1)+DS(I))/(DS(I)+ALPHA(I))
          NU(I) = C*DS(I+1)*(DS(I+1)+DS(I+2))/(DS(I+1)+ALPHA(I))
          LAMBDA(I) = A+MU(I)*B-2.*NU(I)*A
        END DO
        IF (STEEPEN) THEN
          DO I = 2, NI-1
            C = 1./(BETA(I)+DS(I+1))
            SIGMA(I) = C/ALPHA(I)
            TAU(I) = C/BETA(I)
            ZETA(I) = 0.25*(ALPHA(I)*ALPHA(I)-ALPHA(I)*BETA(I)+BETA(I)*
     $BETA(I))
          END DO
        ENDIF
      ENDIF
      DO I = 0, NI+1
        FM(I) = 0.
        FP(I) = 0.
      END DO
      CM(1) = CON(1)
      CM(NI+1) = CON(NI)
      CM(2) = (DS(1)*CON(2)+DS(2)*CON(1))/(DS(1)+DS(2))
      CM(NI) = (DS(NI-1)*CON(NI)+DS(NI)*CON(NI-1))/(DS(NI-1)+DS(NI))
      DO I = 2, NI-1
        DC(I) = CHI(I)*(CON(I+1)-CON(I))+PSI(I)*(CON(I)-CON(I-1))
        IF ((CON(I+1)-CON(I))*(CON(I)-CON(I-1)) .GT. 0.) THEN
          DC(I) = SIGN(1.,DC(I))*MIN(ABS(DC(I)),2.*ABS(CON(I+1)-CON(I)),
     $2.*ABS(CON(I)-CON(I-1)))
        ELSE
          DC(I) = 0.
        ENDIF
      END DO
      DO I = 2, NI-2
        CM(I+1) = CON(I)+LAMBDA(I)*(CON(I+1)-CON(I))-MU(I)*DC(I+1)+NU(I)
     $*DC(I)
      END DO
      DO I = 1, NI
        ETA(I) = 0.
        CLD(I) = CON(I)
        CRD(I) = CON(I)
      END DO
      IF (STEEPEN) THEN
        DO I = 2, NI-1
          D2C(I) = SIGMA(I)*(CON(I+1)-CON(I))-TAU(I)*(CON(I)-CON(I-1))
        END DO
        DO I = 3, NI-2
          IF ((-(D2C(I+1)*D2C(I-1))) .GT. 0. .AND. ABS(CON(I+1)-CON(I-1)
     $)-EPS*MIN(ABS(CON(I+1)),ABS(CON(I-1))) .GT. 0.) THEN
            ETABAR(I) = -(ZETA(I)*(D2C(I+1)-D2C(I-1))/(CON(I+1)-CON(I-1)
     $))
          ELSE
            ETABAR(I) = 0.
          ENDIF
          ETA(I) = MAX(0.,MIN(ETA1*(ETABAR(I)-ETA2),1.))
          CRD(I) = CON(I+1)-0.5*DC(I+1)
          CLD(I) = CON(I-1)+0.5*DC(I-1)
        END DO
      ENDIF
      DO I = 1, NI
        CR(I) = CM(I+1)+ETA(I)*(CRD(I)-CM(I+1))
        CL(I) = CM(I)+ETA(I)*(CLD(I)-CM(I))
        IF ((CR(I)-CON(I))*(CON(I)-CL(I)) .GT. 0.) THEN
          DC(I) = CR(I)-CL(I)
          C6(I) = 6.*(CON(I)-0.5*(CL(I)+CR(I)))
          IF (DC(I)*C6(I) .GT. DC(I)*DC(I)) THEN
            CL(I) = 3.*CON(I)-2.*CR(I)
          ELSE IF ((-(DC(I)*DC(I))) .GT. DC(I)*C6(I)) THEN
            CR(I) = 3.*CON(I)-2.*CL(I)
          ENDIF
        ELSE
          CL(I) = CON(I)
          CR(I) = CON(I)
        ENDIF
        DC(I) = CR(I)-CL(I)
        C6(I) = 6.*(CON(I)-0.5*(CL(I)+CR(I)))
      END DO
      DO I = 1, NI
        IF (VEL(I) .LT. 0.) THEN
          Y = -(VEL(I)*DT)
          X = Y/DS(I)
          FM(I) = Y*(CL(I)+0.5*X*(DC(I)+C6(I)*(1.-TWO3RDS*X)))
        ENDIF
      END DO
      DO I = 1, NI-1
        IF (VEL(I+1) .GT. 0.) THEN
          Y = VEL(I+1)*DT
          X = Y/DS(I)
          FP(I) = Y*(CR(I)-0.5*X*(DC(I)-C6(I)*(1.-TWO3RDS*X)))
        ENDIF
      END DO
      DO I = 1, NI
        CON(I) = CON(I)+(FP(I-1)-FP(I)+FM(I+1)-FM(I))/DS(I)
      END DO

C----------------------------------------------
C SAVE DEPENDEND VARIABLES
C----------------------------------------------
      CONI(:) = CON(:)

C----------------------------------------------
C ADJOINT COMPUTATIONS
C----------------------------------------------
      DO I = 1, NI
        ADFM(I+1) = ADFM(I+1)+ADCON(I)/DS(I)
        ADFM(I) = ADFM(I)-ADCON(I)/DS(I)
        ADFP(I-1) = ADFP(I-1)+ADCON(I)/DS(I)
        ADFP(I) = ADFP(I)-ADCON(I)/DS(I)
      END DO
      DO I = 1, NI-1
        IF (VEL(I+1) .GT. 0.) THEN
          Y = VEL(I+1)*DT
          X = Y/DS(I)
          ADC6(I) = ADC6(I)+0.5*ADFP(I)*Y*X*(1.-TWO3RDS*X)
          ADCR(I) = ADCR(I)+ADFP(I)*Y
          ADDC(I) = ADDC(I)-0.5*ADFP(I)*Y*X
          ADFP(I) = 0.
        ENDIF
      END DO
      DO I = 1, NI
        IF (VEL(I) .LT. 0.) THEN
          Y = -(VEL(I)*DT)
          X = Y/DS(I)
          ADC6(I) = ADC6(I)+0.5*ADFM(I)*Y*X*(1.-TWO3RDS*X)
          ADCL(I) = ADCL(I)+ADFM(I)*Y
          ADDC(I) = ADDC(I)+0.5*ADFM(I)*Y*X
          ADFM(I) = 0.
        ENDIF
      END DO
      CON(:) = CONH(:)
      DO I = 1, NI
        CR(I) = CM(I+1)+ETA(I)*(CRD(I)-CM(I+1))
        CL(I) = CM(I)+ETA(I)*(CLD(I)-CM(I))
        ADCL(I) = ADCL(I)-3*ADC6(I)
        ADCON(I) = ADCON(I)+6*ADC6(I)
        ADCR(I) = ADCR(I)-3*ADC6(I)
        ADC6(I) = 0.
        ADCL(I) = ADCL(I)-ADDC(I)
        ADCR(I) = ADCR(I)+ADDC(I)
        ADDC(I) = 0.
        IF ((CR(I)-CON(I))*(CON(I)-CL(I)) .GT. 0.) THEN
          DC(I) = CR(I)-CL(I)
          C6(I) = 6.*(CON(I)-0.5*(CL(I)+CR(I)))
          IF (DC(I)*C6(I) .GT. DC(I)*DC(I)) THEN
            ADCON(I) = ADCON(I)+3*ADCL(I)
            ADCR(I) = ADCR(I)-2*ADCL(I)
            ADCL(I) = 0.
          ELSE IF ((-(DC(I)*DC(I))) .GT. DC(I)*C6(I)) THEN
            ADCL(I) = ADCL(I)-2*ADCR(I)
            ADCON(I) = ADCON(I)+3*ADCR(I)
            ADCR(I) = 0.
          ENDIF
          ADCL(I) = ADCL(I)-3*ADC6(I)
          ADCON(I) = ADCON(I)+6*ADC6(I)
          ADCR(I) = ADCR(I)-3*ADC6(I)
          ADC6(I) = 0.
          ADCL(I) = ADCL(I)-ADDC(I)
          ADCR(I) = ADCR(I)+ADDC(I)
          ADDC(I) = 0.
        ELSE
          ADCON(I) = ADCON(I)+ADCR(I)
          ADCR(I) = 0.
          ADCON(I) = ADCON(I)+ADCL(I)
          ADCL(I) = 0.
        ENDIF
        ADCLD(I) = ADCLD(I)+ADCL(I)*ETA(I)
        ADCM(I) = ADCM(I)+ADCL(I)*(1-ETA(I))
        ADETA(I) = ADETA(I)+ADCL(I)*(CLD(I)-CM(I))
        ADCL(I) = 0.
        ADCM(I+1) = ADCM(I+1)+ADCR(I)*(1-ETA(I))
        ADCRD(I) = ADCRD(I)+ADCR(I)*ETA(I)
        ADETA(I) = ADETA(I)+ADCR(I)*(CRD(I)-CM(I+1))
        ADCR(I) = 0.
      END DO
      IF (STEEPEN) THEN
        DO I = 3, NI-2
          IF ((-(D2C(I+1)*D2C(I-1))) .GT. 0. .AND. ABS(CON(I+1)-CON(I-1)
     $)-EPS*MIN(ABS(CON(I+1)),ABS(CON(I-1))) .GT. 0.) THEN
            ETABAR(I) = -(ZETA(I)*(D2C(I+1)-D2C(I-1))/(CON(I+1)-CON(I-1)
     $))
          ELSE
            ETABAR(I) = 0.
          ENDIF
          ADCON(I-1) = ADCON(I-1)+ADCLD(I)
          ADDC(I-1) = ADDC(I-1)+0.5*ADCLD(I)
          ADCLD(I) = 0.
          ADCON(I+1) = ADCON(I+1)+ADCRD(I)
          ADDC(I+1) = ADDC(I+1)-0.5*ADCRD(I)
          ADCRD(I) = 0.
          ADETABAR(I) = ADETABAR(I)+ADETA(I)*(0.5-SIGN(0.5,0.-MIN(ETA1*
     $(ETABAR(I)-ETA2),1.)))*(0.5+SIGN(0.5,1.-ETA1*(ETABAR(I)-ETA2)))*
     $ETA1
          ADETA(I) = 0.
          IF ((-(D2C(I+1)*D2C(I-1))) .GT. 0. .AND. ABS(CON(I+1)-CON(I-1)
     $)-EPS*MIN(ABS(CON(I+1)),ABS(CON(I-1))) .GT. 0.) THEN
            ADCON(I-1) = ADCON(I-1)-ADETABAR(I)*(ZETA(I)*(D2C(I+1)-
     $D2C(I-1))/((CON(I+1)-CON(I-1))*(CON(I+1)-CON(I-1))))
            ADCON(I+1) = ADCON(I+1)+ADETABAR(I)*(ZETA(I)*(D2C(I+1)-
     $D2C(I-1))/((CON(I+1)-CON(I-1))*(CON(I+1)-CON(I-1))))
            ADD2C(I-1) = ADD2C(I-1)+ADETABAR(I)*(ZETA(I)/(CON(I+1)-
     $CON(I-1)))
            ADD2C(I+1) = ADD2C(I+1)-ADETABAR(I)*(ZETA(I)/(CON(I+1)-
     $CON(I-1)))
            ADETABAR(I) = 0.
          ELSE
            ADETABAR(I) = 0.
          ENDIF
        END DO
        DO I = 2, NI-1
          ADCON(I-1) = ADCON(I-1)+ADD2C(I)*TAU(I)
          ADCON(I+1) = ADCON(I+1)+ADD2C(I)*SIGMA(I)
          ADCON(I) = ADCON(I)-ADD2C(I)*(SIGMA(I)+TAU(I))
          ADD2C(I) = 0.
        END DO
      ENDIF
      DO I = 1, NI
        ADCON(I) = ADCON(I)+ADCRD(I)
        ADCRD(I) = 0.
        ADCON(I) = ADCON(I)+ADCLD(I)
        ADCLD(I) = 0.
      END DO
      DO I = 2, NI-2
        ADCON(I+1) = ADCON(I+1)+ADCM(I+1)*LAMBDA(I)
        ADCON(I) = ADCON(I)+ADCM(I+1)*(1-LAMBDA(I))
        ADDC(I+1) = ADDC(I+1)-ADCM(I+1)*MU(I)
        ADDC(I) = ADDC(I)+ADCM(I+1)*NU(I)
        ADCM(I+1) = 0.
      END DO
      DO I = 2, NI-1
        DC(I) = CHI(I)*(CON(I+1)-CON(I))+PSI(I)*(CON(I)-CON(I-1))
        IF ((CON(I+1)-CON(I))*(CON(I)-CON(I-1)) .GT. 0.) THEN
          ADCON(I+1) = ADCON(I+1)+2.*ADDC(I)*(0.5-SIGN(0.5,2.*ABS(CON(I+
     $1)-CON(I))-ABS(DC(I))))*SIGN(1.,CON(I+1)-CON(I))*SIGN(1.,DC(I))
          ADCON(I) = ADCON(I)-2.*ADDC(I)*(0.5-SIGN(0.5,2.*ABS(CON(I+1)-
     $CON(I))-ABS(DC(I))))*SIGN(1.,CON(I+1)-CON(I))*SIGN(1.,DC(I))
          ADDC(I) = ADDC(I)*(0.5+SIGN(0.5,2.*ABS(CON(I+1)-CON(I))-
     $ABS(DC(I))))*SIGN(1.,DC(I))*SIGN(1.,DC(I))
        ELSE
          ADDC(I) = 0.
        ENDIF
        ADCON(I-1) = ADCON(I-1)-ADDC(I)*PSI(I)
        ADCON(I+1) = ADCON(I+1)+ADDC(I)*CHI(I)
        ADCON(I) = ADCON(I)+ADDC(I)*((-CHI(I))+PSI(I))
        ADDC(I) = 0.
      END DO
      ADCON(NI-1) = ADCON(NI-1)+ADCM(NI)*(DS(NI)/(DS(NI-1)+DS(NI)))
      ADCON(NI) = ADCON(NI)+ADCM(NI)*(DS(NI-1)/(DS(NI-1)+DS(NI)))
      ADCM(NI) = 0.
      ADCON(2) = ADCON(2)+ADCM(2)*(DS(1)/(DS(1)+DS(2)))
      ADCON(1) = ADCON(1)+ADCM(2)*(DS(2)/(DS(1)+DS(2)))
      ADCM(2) = 0.
      ADCON(NI) = ADCON(NI)+ADCM(NI+1)
      ADCM(NI+1) = 0.
      ADCON(1) = ADCON(1)+ADCM(1)
      ADCM(1) = 0.

C----------------------------------------------
C GET DEPENDEND VARIABLES
C----------------------------------------------
      CON(:) = CONI(:)


      END SUBROUTINE ADVPPM


