
C***********************************************************************
C   Portions of Models-3/CMAQ software were developed or based on      *
C   information from various groups: Federal Government employees,     *
C   contractors working on a United States Government contract, and    *
C   non-Federal sources (including research institutions).  These      *
C   research institutions have given the Government permission to      *
C   use, prepare derivative works, and distribute copies of their      *
C   work in Models-3/CMAQ to the public and to permit others to do     *
C   so.  EPA therefore grants similar permissions for use of the       *
C   Models-3/CMAQ software, but users are requested to provide copies  *
C   of derivative works to the Government without restrictions as to   *
C   use by others.  Users are responsible for acquiring their own      *
C   copies of commercial software associated with Models-3/CMAQ and    *
C   for complying with vendor requirements.  Software copyrights by    *
C   the MCNC Environmental Modeling Center are used with their         *
C   permissions subject to the above restrictions.                     *
C***********************************************************************

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DEFINE_RECEPTOR( LGRID )

C Function:
C     Subroutine to define the receptor,i.e., initialize LGRID 
C      -> initialize LGRID with certain value for species for 
C         which the sensitivity analysis has to be performed.

C CAUTION:
C     -> Driver designed to perform sensitivity test with ozone
 
C Revision History:
C     Kumaresh Singh & Sandu,A. Apr 07 - Added to perform Finite-Difference 
C     and Sensitivity test
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID species number and offsets

      IMPLICIT NONE

!     REAL         CGRID( NCOLS,NROWS,NLAYS,* )
      REAL, POINTER :: LGRID( :,:,:,: )

C-----------------------------------------------------------------------

C     =======================================
C     Initializing adjoint variable LGRID
C     =======================================
     
      LGRID(18:22,18:22,1:4,4) = 1.d0
!      LGRID(23,6:10,1:NLAYS,4) = 1.d0
!     LGRID(15,13,1,4) = 1.d0     
!     LGRID(15:30,10:25,5,4) = 1.d0
      RETURN 
      END
      
